<?php

namespace App\Controller;

use App\Entity\ReponsePossible;
use App\Form\ReponsePossibleType;
use App\Repository\ReponsePossibleRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

#[Route('/reponse/possible')]
final class ReponsePossibleController extends AbstractController
{
    #[Route(name: 'app_reponse_possible_index', methods: ['GET'])]
    public function index(ReponsePossibleRepository $reponsePossibleRepository): Response
    {
        return $this->render('reponse_possible/index.html.twig', [
            'reponse_possibles' => $reponsePossibleRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'app_reponse_possible_new', methods: ['GET', 'POST'])]
    public function new(Request $request, EntityManagerInterface $entityManager): Response
    {
        $reponsePossible = new ReponsePossible();
        $form = $this->createForm(ReponsePossibleType::class, $reponsePossible);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->persist($reponsePossible);
            $entityManager->flush();

            return $this->redirectToRoute('app_reponse_possible_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->render('reponse_possible/new.html.twig', [
            'reponse_possible' => $reponsePossible,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_reponse_possible_show', methods: ['GET'])]
    public function show(ReponsePossible $reponsePossible): Response
    {
        return $this->render('reponse_possible/show.html.twig', [
            'reponse_possible' => $reponsePossible,
        ]);
    }

    #[Route('/{id}/edit', name: 'app_reponse_possible_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, ReponsePossible $reponsePossible, EntityManagerInterface $entityManager): Response
    {
        $form = $this->createForm(ReponsePossibleType::class, $reponsePossible);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->flush();

            return $this->redirectToRoute('app_reponse_possible_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->render('reponse_possible/edit.html.twig', [
            'reponse_possible' => $reponsePossible,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_reponse_possible_delete', methods: ['POST'])]
    public function delete(Request $request, ReponsePossible $reponsePossible, EntityManagerInterface $entityManager): Response
    {
        if ($this->isCsrfTokenValid('delete'.$reponsePossible->getId(), $request->getPayload()->getString('_token'))) {
            $entityManager->remove($reponsePossible);
            $entityManager->flush();
        }

        return $this->redirectToRoute('app_reponse_possible_index', [], Response::HTTP_SEE_OTHER);
    }
}
