<?php

namespace App\Entity;

use App\Repository\ReponseUtilisateurRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: ReponseUtilisateurRepository::class)]
class ReponseUtilisateur
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(type: Types::TEXT, nullable: true)]
    private ?string $valeurLibre = null;

    #[ORM\ManyToOne(inversedBy: 'reponses')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Test $test = null;

    #[ORM\ManyToOne(inversedBy: 'reponseUtilisateurs')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Question $question = null;

    #[ORM\ManyToOne]
    private ?ReponsePossible $reponse = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getValeurLibre(): ?string
    {
        return $this->valeurLibre;
    }

    public function setValeurLibre(?string $valeurLibre): static
    {
        $this->valeurLibre = $valeurLibre;

        return $this;
    }

    public function getTest(): ?Test
    {
        return $this->test;
    }

    public function setTest(?Test $test): static
    {
        $this->test = $test;

        return $this;
    }

    public function getQuestion(): ?Question
    {
        return $this->question;
    }

    public function setQuestion(?Question $question): static
    {
        $this->question = $question;

        return $this;
    }

    public function getReponse(): ?ReponsePossible
    {
        return $this->reponse;
    }

    public function setReponse(?ReponsePossible $reponse): static
    {
        $this->reponse = $reponse;

        return $this;
    }
}
