<?php

namespace App\Entity;

use App\Repository\UsagerRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use App\Entity\User;

#[ORM\Entity(repositoryClass: UsagerRepository::class)]
class Usager
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $usagerNom = null;

    #[ORM\Column(length: 255)]
    private ?string $usager_prenom = null;

    #[ORM\Column(length: 20, nullable: true)]
    private ?string $usager_tel = null;

    #[ORM\Column]
    private ?int $structureId = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
    private ?\DateTimeInterface $created_at = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
    private ?\DateTimeInterface $updated_at = null;

    #[ORM\ManyToOne(inversedBy: 'usagers')]
    #[ORM\JoinColumn(nullable: false)]
    private ?User $conseiller = null;

    /**
     * @var Collection<int, Test>
     */
    #[ORM\OneToMany(targetEntity: Test::class, mappedBy: 'usager')]
    private Collection $tests;

    public function __construct()
    {
        $this->tests = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getUsagerNom(): ?string
    {
        return $this->usagerNom;
    }

    public function setUsagerNom(string $usagerNom): static
    {
        $this->usagerNom = $usagerNom;

        return $this;
    }

    public function getUsagerPrenom(): ?string
    {
        return $this->usager_prenom;
    }

    public function setUsagerPrenom(string $usager_prenom): static
    {
        $this->usager_prenom = $usager_prenom;

        return $this;
    }

    public function getUsagerTel(): ?string
    {
        return $this->usager_tel;
    }

    public function setUsagerTel(?string $usager_tel): static
    {
        $this->usager_tel = $usager_tel;

        return $this;
    }

    public function getStructureId(): ?int
    {
        return $this->structureId;
    }

    public function setStructureId(int $structureId): static
    {
        $this->structureId = $structureId;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->created_at;
    }

    public function setCreatedAt(\DateTimeInterface $created_at): static
    {
        $this->created_at = $created_at;

        return $this;
    }

    public function getUpdatedAt(): ?\DateTimeInterface
    {
        return $this->updated_at;
    }

    public function setUpdatedAt(\DateTimeInterface $updated_at): static
    {
        $this->updated_at = $updated_at;

        return $this;
    }

    public function getConseiller(): ?User
    {
        return $this->conseiller;
    }

    public function setConseiller(?User $conseiller): static
    {
        $this->conseiller = $conseiller;

        return $this;
    }

    /**
     * @return Collection<int, Test>
     */
    public function getTests(): Collection
    {
        return $this->tests;
    }

    public function addTest(Test $test): static
    {
        if (!$this->tests->contains($test)) {
            $this->tests->add($test);
            $test->setUsager($this);
        }

        return $this;
    }

    public function removeTest(Test $test): static
    {
        if ($this->tests->removeElement($test)) {
            // set the owning side to null (unless already changed)
            if ($test->getUsager() === $this) {
                $test->setUsager(null);
            }
        }

        return $this;
    }
}
