<?php

namespace App\Form;

use App\Entity\Question;
use App\Entity\ReponsePossible;
use App\Entity\ReponseUtilisateur;
use App\Entity\Test;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ReponseUtilisateurType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('valeurLibre')
            ->add('test', EntityType::class, [
                'class' => test::class,
                'choice_label' => 'id',
            ])
            ->add('question', EntityType::class, [
                'class' => question::class,
                'choice_label' => 'id',
            ])
            ->add('reponse', EntityType::class, [
                'class' => ReponsePossible::class,
                'choice_label' => 'id',
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => ReponseUtilisateur::class,
        ]);
    }
}
